#!/usr/bin/perl -w
use strict;
srand( time^( $$ + ( $$ << 15 ) ) );

my $file_id = int( rand( 10000000 ) );

if( !( -e "_tmp" ) ) { 
	print "Create a temporary dir _tmp\n";
	mkdir( "_tmp" );
}
else {
	print "Temporary dir _tmp has already exist.\n";
	
	while( -e "./_tmp/dist_matrix.$file_id.txt" ) {
		$file_id = int( rand( 10000000 ) );
	}
}

my $infile1 = $ARGV[0]; # the gene expression matrix of the responsive genes (differentially genes)
my $dist_cut = $ARGV[1]; # default: (1-corr_p_0.05)/2; type:cut
                         # corr:[-1~+1] / dist:[0~1], dist=(1-corr)/2 /spearman_zscore
my $min_cluster_size = $ARGV[2]; # default: 10% of the total number of the studied genes.
                                 # 2000 responsive genes => 2000*0.10=200
#my $max_delta_size_for_new_cluster = $ARGV[3];
#my $outfile1 = $ARGV[4]; #./_tmp/cluster.ready.txt
my $outfile1 = $ARGV[3];

open( in1, "<$infile1" );
my $line1 = <in1>;
chomp( $line1 );
my @col_names = split( /\t/, $line1 );
my $col_num = $#col_names + 1 - 1;
close( in1 );

my ( $type, $score1 ) = split( /:/, $dist_cut, 2 );
if( $type eq "corr" ) { $dist_cut = ( 1 - $score1 ) / 2; }
if( $type eq "dist" ) { $dist_cut = $score1; }
if( $type eq "spearman_zscore" ) {
	my $c1 = exp( 2 * $score1 * sqrt( 1.06 / ( $col_num - 3 ) ) );
	my $corr1 = ( $c1 - 1 ) / ( $c1 + 1 );
	$dist_cut = ( 1 - $corr1 ) / 2; # zscore = 0.52 <=> p-value ~= 0.3; 1.28 <=> 0.1; 1.65 <=> 0.05; 2.33 <=> 0.01
}

### print $dist_cut; exit;

my $cmd = '';
print "Caculate the gene-gene distance....\n";
#$cmd = "perl clustering.step1_calculate_the_dist.pl $infile1 ./_tmp/dist_matrix.txt";
$cmd = "perl clustering.step1_calculate_the_dist.spearman.pl $infile1 ./_tmp/dist_matrix.$file_id.txt";
print "\t$cmd\n";
system( $cmd );

print "Hierarchical clustering....\n";
$cmd = "perl clustering.step2_hierarchical_clustering.pl ./_tmp/dist_matrix.$file_id.txt $dist_cut ./_tmp/cluster.raw.$file_id.txt > ./_tmp/1.$file_id.txt";
print "\t$cmd\n";
system( $cmd );

print "Extract clusters....\n";
$cmd = "perl clustering.step3_extract_cluster.pl ./_tmp/cluster.raw.$file_id.txt ./_tmp/dist_matrix.$file_id.txt $min_cluster_size ./_tmp/cluster.ready_0.$file_id.txt";
print "\t$cmd\n";
system( $cmd );

$cmd = "perl clustering.step4_cluster_format.pl ./_tmp/cluster.ready_0.$file_id.txt $infile1 > $outfile1";
print "\t$cmd\n";
system( $cmd );
