#!/usr/bin/perl -w
use strict;
use List::Util qw(first max maxstr min minstr reduce shuffle sum);

my $infile_expr = $ARGV[0];
my $outfile1 = $ARGV[1];

open( in1, "<$infile_expr" );
my $header1 = <in1>;
my @data1 = <in1>;
chomp( @data1 );
close( in1 );

open( out1, ">$outfile1" );
for( my $i = 0; $i < $#data1; $i++ ){
	#my ( $id1, $symbol1, $expr1 ) = split( /\t/, $data1[$i], 3 );
	my ( $id1, $expr1 ) = split( /\t/, $data1[$i], 2 );
	print out1 join( "\t", $id1, $id1, 0 ), "\n"; # "0" means the distance is zero
	for( my $j = $i + 1; $j <= $#data1; $j++ ) {
		#my ( $id2, $symbol2, $expr2 ) = split( /\t/, $data1[$j], 3 );
		my ( $id2, $expr2 ) = split( /\t/, $data1[$j], 2 );
		
		my $corr1 = corr( $expr1, $expr2 );
		#print out1 join( "\t", $id1, $id2, 1 - abs( $corr1 ) ), "\n";
		print out1 join( "\t", $id1, $id2, ( 1 - $corr1 ) / 2 ), "\n";
	}
}
close( out1 );

sub std {
	my @arr_p=@_;
	
	my $mean=sum(@arr_p)/($#arr_p+1);
	
	my $var=0;
	for(my $si=0;$si<=$#arr_p;$si++) {
		my $diff=$arr_p[$si]-$mean;
		$var=$var+$diff*$diff;
	}
	$var=$var/$#arr_p;
	
	return sqrt($var);
}

sub corr {
	my ( $vector1, $vector2 ) = @_;
	
	my @data1 = split(/\t/,$vector1);
	my @data2 = split(/\t/,$vector2);
	
	if($#data1 ne $#data2) {
		print "Error in funcntion (corr): vector sizes do not match. Exiting.\n";
		exit;
	}
	
	my $mean1 = sum(@data1)/($#data1+1);
	my $mean2 = sum(@data2)/($#data2+1);
	my $std1 = std(@data1);
	my $std2 = std(@data2);
	
	if(($mean1 == 0 && $std1==0) || ($mean2==0 && $std2==0)) {
		return "0"; #пȫ0Уֱ
	}
	
	my $corr = 0;
	for( my $i=0; $i <= $#data1; $i++ ) {
		$corr = $corr + ( $data1[$i] - $mean1 ) * ( $data2[$i] - $mean2 );
	}
	
	$corr = $corr / ( $#data1 + 1 ) / $std1 / $std2;
	return $corr;
}
