#!/usr/bin/perl -w
use strict;

# clustercluster֮ľо

my $infile1 = $ARGV[0]; # similarity file, gse9055_entrez_id_hprd_ppi.shortest_path.dig.txt
my $dist_cut = $ARGV[1];
my $outfile1 = $ARGV[2];
my %cluster = ();
# my $cid = 0;
my %distance = ();
open( in1, "<$infile1" );
while( my $line = <in1> ) {
	chomp( $line );
	my ( $id1, $id2, $dist ) = split( /\t/, $line, 3 );
	if( $id1 eq $id2 ) {
		# $cid++;
		# initiate cluster with single gene
		$cluster{ $id1 } = $id1;
	}
	else {
		if( !exists( $distance{ "$id2\t$id1" } ) ) {
			$distance{ "$id1\t$id2" } = $dist;
			# print "$id1\t$id2\t", $distance{ "$id1\t$id2" }, "\n";
		}
	}
}
close( in1 );
# exit;

open( out1, ">$outfile1" );
my %cluster_dist = %distance;
while( 1 ) {
	my @pair_dist = sort { $cluster_dist{ $a } <=> $cluster_dist{ $b } } keys %cluster_dist;
	if( $#pair_dist <= 0 || $cluster_dist{ $pair_dist[0] } > $dist_cut ) {
		#print "Clustering $pair_dist[0]\n";
		#print "\tDistance is ".$cluster_dist{ $pair_dist[0] }."\n";
		#print "Clustering finished.\n";
		
		#print "*" x 60,  "\n";
		#output_cluster();
		
		last;
	}
		
	my ( $cluster1, $cluster2 ) = split( /\t/, $pair_dist[0] );
	
	print "Clustering $cluster1 $cluster2\n";
	print out1 "Clustering $cluster1 $cluster2\n";
	print out1 "\tDistance is ".$cluster_dist{ $pair_dist[0] }."\n";
	print out1 "\tIn cluster distance is ".incluster_dist( "$cluster1:$cluster2" );
	print out1 "\n";
	
	my $new_cluster = "$cluster1:$cluster2";
	delete $cluster_dist{ $pair_dist[0] };
	
	#---- merge two clusters into a new one ----
	for( my $i = 1; $i <= $#pair_dist; $i++ ) {
		my ( $fcluster1, $fcluster2 ) = split( /\t/, $pair_dist[$i] );
		if( $fcluster1 eq $cluster2 || $fcluster2 eq $cluster2 ) {
			delete $cluster_dist{ $pair_dist[$i] };
			next;
		}
		
		if( $fcluster1 eq $cluster1 ) {
			my $new_dist = merge_dist( $new_cluster, $fcluster2 );
			$cluster_dist{ $new_cluster."\t".$fcluster2 } = $new_dist;
			delete $cluster_dist{ $pair_dist[$i] };
			next;
		}
		
		if( $fcluster2 eq $cluster1 ) {
			my $new_dist = merge_dist( $new_cluster, $fcluster1 );
			$cluster_dist{ $new_cluster."\t".$fcluster1 } = $new_dist;
			delete $cluster_dist{ $pair_dist[$i] };
		}
	}
	
	#exit;
}
close( out1 );

sub merge_dist {
	my ( $cluster1, $cluster2 ) = @_;
	
	#print $cluster2, "\n";
	#exit;
	
	my @arr1 = split( /:/, $cluster1 );
	my @arr2 = split( /:/, $cluster2 );
	
	my $tot_dist = 0;
	my $max_dist = 0;
	for( my $i = 0; $i <= $#arr1; $i++ ) {
		for( my $j = 0; $j <= $#arr2; $j++ ) {
			my $dist_id = $arr1[$i]."\t".$arr2[$j];
			
			if( exists( $distance{ $dist_id } ) ) {
				$tot_dist = $tot_dist + $distance{ $dist_id };
				
				if( $distance{ $dist_id } > $max_dist ) {
					$max_dist = $distance{ $dist_id };
				}
			}
			else {
				$dist_id = $arr2[$j]."\t".$arr1[$i];
				$tot_dist = $tot_dist + $distance{ $dist_id };
				
				if( $distance{ $dist_id } > $max_dist ) {
					$max_dist = $distance{ $dist_id };
				}
			}
		}
	}
	
	return $tot_dist / ( $#arr1 + 1 ) / ( $#arr2 + 1 );
	#return $max_dist;
}

sub incluster_dist {
	my $cluster1 = $_[0];
	
	#print $cluster2, "\n";
	#exit;
	
	my @arr1 = split( /:/, $cluster1 );
	my $n1 = 0;
	#my @arr2 = split( /:/, $cluster1 );
	
	my $tot_dist = 0;
	my $max_dist = 0;
	for( my $i = 0; $i < $#arr1; $i++ ) {
		for( my $j = $i + 1; $j <= $#arr1; $j++ ) {
			my $dist_id = $arr1[$i]."\t".$arr1[$j];
			
			if( exists( $distance{ $dist_id } ) ) {
				$tot_dist = $tot_dist + $distance{ $dist_id };
				
				if( $distance{ $dist_id } > $max_dist ) {
					$max_dist = $distance{ $dist_id };
				}
			}
			else {
				$dist_id = $arr1[$j]."\t".$arr1[$i];
				$tot_dist = $tot_dist + $distance{ $dist_id };
				
				if( $distance{ $dist_id } > $max_dist ) {
					$max_dist = $distance{ $dist_id };
				}
			}
			
			$n1++;
		}
	}
	
	if( $n1 == 0 ) {
		return 0;
	}
	
	return $tot_dist / $n1;
	#return $max_dist;
}

sub output_cluster {
	my @data = keys %cluster_dist;
	my %output_cluster = ();
	for( my $i = 0; $i <= $#data; $i++ ) {
		my ( $cluster1, $cluster2 ) = split( /\t/, $data[$i] );
		if( !exists( $output_cluster{ $cluster1 } ) ) {
			print incluster_dist( $cluster1 ), "\t", $cluster1, "\n";
			$output_cluster{ $cluster1 } = 'yes';
		}
		
		if( !exists( $output_cluster{ $cluster2 } ) ) {
			print incluster_dist( $cluster2 ), "\t", $cluster2, "\n";
			$output_cluster{ $cluster2 } = 'yes';
		}
	}
}
