#!/usr/bin/perl -w
use strict;
use List::Util qw(first max maxstr min minstr reduce shuffle sum);

my $infile_cluster = $ARGV[0];
my $infile_dist = $ARGV[1];
my $min_cluster_size = $ARGV[2]; # Сcluster
my $outfile1 = $ARGV[3];
my $min_delta_cluster_size_ratio = 0.1; # Сclusterδﵽϴ0.1ֻжǷչ
my $min_delta_cluster_size = 20; # Сclusterδﵽ20ֻжǷչ
my $max_cluster_extend_dist = 1.0;
my $merge_cut = 0.5; # clusterֵ<0.5Сϲ

#my %cluster_merge_dist = ();
#my %cluster_intra_dist = ();
my %cluster_lchild = ();
my %cluster_rchild = ();
my %cluster_parent = ();
my @cluster = ();
my %leaf_cluster = ();
print "Reading the clustering result....\n";
my $i_cluster = 0;
open( in1, "<$infile_cluster" );
while( my $line1 = <in1> ) {
	###Clustering 1193:1880:6943:3587 9450:64231:51338:2124:55843
	###	Distance is 0.0668095720919297
	###	In cluster distance is 0.0620359621509478
	
	chomp( $line1 );
	my ( $tag1, $child1, $child2 ) = split( /\s/, $line1 );
	my $cluster1 = "$child1:$child2";  # ǰcluster
	
	# cluster̫С<$min_cluster_sizeд
	if( cluster_size( $cluster1 ) < $min_cluster_size ) {
		next;
	}
	
	$i_cluster++;
	$line1 = <in1>;
	#chomp( $line1 );
	#my @arr1 = split( /\s/, $line1 );
	#my $merge_dist = pop( @arr1 );
	
	$line1 = <in1>;
	#chomp( $line1 );
	#@arr1 = split( /\s/, $line1 );
	#my $intra_dist = pop( @arr1 );
	
	push( @cluster, $cluster1 );
	#$cluster_merge_dist{ $cluster1 } = $merge_dist;
	#$cluster_intra_dist{ $cluster1 } = $intra_dist;
	
	my $size1 = cluster_size( $child1 );
	my $size2 = cluster_size( $child2 );
	
	# lchildΪϴķ֧rchildн
	if( $size1 < $size2 ) {
		my $t1 = $size2;
		$size2 = $size1;
		$size1 = $t1;
		
		$t1 = $child2;
		$child2 = $child1;
		$child1 = $t1;
	}
	
	print "  $i_cluster\t".( $size1 + $size2 );
	
	# ϴ֧СֵclusterΪҶӽڵ㣬ӽڵ
	if( $size1 >= $min_cluster_size ) {
		$cluster_lchild{ $cluster1 } = $child1;
		$cluster_rchild{ $cluster1 } = $child2;
		
		$cluster_parent{ $child1 } = $cluster1;
		$cluster_parent{ $child2 } = $cluster1;
		
		if( $size2 < $min_cluster_size ) {
			$leaf_cluster{ $child2 } = "leaf";
			print "\t***\t$size2\tLEAF";
		}
	}
	else {
		$leaf_cluster{ $cluster1 } = "leaf";
		print "\tLEAF";
	}
	
	print "\n";
}
close( in1 );
print "Finished.\n";

my %gene_dist = ();
print "Reading distance matrix....\n";
open( in2, "<$infile_dist" );
while( my $line2 = <in2> ) {
	chomp( $line2 );
	my ( $id1, $id2, $dist1, $desc1 ) = split( /\t/, $line2, 4 );
	$gene_dist{ "$id1\t$id2" } = $dist1;
	$gene_dist{ "$id2\t$id1" } = $dist1;
}
close( in2 );
print "Finished.\n\n";

##########################################
print "Processing cluster extracting...\n";
my %cluster_state = ();
open( out1, ">$outfile1" );
my $i_run = 0;
while( 1 ) {
	$i_run++;
	
	# lchild/rchildҶӽڵľ
	for( my $i = 0; $i <= $#cluster; $i++ ) {
		my $cluster1 = $cluster[$i];
		
		#Ҷӽڵڵ
		if( !exists( $cluster_lchild{ $cluster1 } ) || !exists( $cluster_rchild{ $cluster1 } ) ) {
			if( exists( $leaf_cluster{ $cluster1 } ) && !exists( $cluster_parent{ $cluster1 } ) ) {
				print out1 $cluster1, "\n";
				print "o:l\n";
				delete( $leaf_cluster{ $cluster1 } );
			}
			next;
		}
		
		my $lchild = $cluster_lchild{ $cluster1 };
		my $rchild = $cluster_rchild{ $cluster1 };
		
		#һӽڵ㲻Ҷӽڵ
		if( !exists( $leaf_cluster{ $lchild } ) || !exists( $leaf_cluster{ $rchild } ) ){
			next;
		}
				
		my $size1 = cluster_size( $lchild );
		my $size2 = cluster_size( $rchild );
		
		my @l_cluster = split( /:/, $lchild );
		my @r_cluster = split( /:/, $rchild );
		
		#rchildСϽкϲԶlchildǰڵ
		if( $size2 < $min_delta_cluster_size || $size2 / $size1 < $min_delta_cluster_size_ratio ) {
			my $inter_dist12 = cluster_inter_dist( \@l_cluster, \@r_cluster, \%gene_dist );
			my ( $intra_dist1, $intra_dist1_std ) = split( /\t/, cluster_intra_dist( \@l_cluster, \%gene_dist ), 2 );
			
			# ϲ/ȥھھķбȽϣֵԽ˵ӽڵԽԶ
			my $inter_normalize_dist = ( $inter_dist12 - $intra_dist1 ) / $intra_dist1_std;
			
			if( $inter_normalize_dist > $merge_cut ) {
				# ǰڵѾǸڵ㣬׼
				if( !exists( $cluster_parent{ $cluster1 } ) ) {
					print out1 $lchild, "\n";
					print "l";
					print ":r11\n";
					
					delete( $cluster_lchild{ $cluster1 } );
					delete( $cluster_rchild{ $cluster1 } );
					
					delete( $cluster_parent{ $lchild } );
					delete( $cluster_parent{ $rchild } );
					
					delete( $leaf_cluster{ $lchild } );
					delete( $leaf_cluster{ $rchild } );
					next;
				}				
				
				# ǰڵlchildĸڵΪǰڵĸڵ
				my $parent1 = $cluster_parent{ $cluster1 };
				$cluster_parent{ $lchild } = $parent1;
				
				# ǰڵĸڵӽڵΪǰڵlchildж/ӽڵ
				if( $cluster_lchild{ $parent1 } eq $cluster1 ) {
					$cluster_lchild{ $parent1 } = $lchild;
				}
				else {
					if( $cluster_rchild{ $parent1 } ne $cluster1 ) {
						print "ERROR: $parent1 is not the parent of $cluster1!\n"; exit;
					}
					
					$cluster_rchild{ $parent1 } = $lchild;
				}
				
				delete( $cluster_lchild{ $cluster1 } );
				delete( $cluster_rchild{ $cluster1 } );
				
				delete( $cluster_parent{ $cluster1 } );
				delete( $cluster_parent{ $rchild } );
				
				delete( $leaf_cluster{ $rchild } );
			}
			else {
				# ǰڵѾǸڵ㣬׼
				if( !exists( $cluster_parent{ $cluster1 } ) ) {
					print out1 $cluster1, "\n";
					print "c";
					print ":r12\n";
					
					delete( $cluster_lchild{ $cluster1 } );
					delete( $cluster_rchild{ $cluster1 } );
					
					delete( $cluster_parent{ $lchild } );
					delete( $cluster_parent{ $rchild } );
					
					delete( $leaf_cluster{ $lchild } );
					delete( $leaf_cluster{ $rchild } );
					next;
				}				
				
				delete( $cluster_lchild{ $cluster1 } );
				delete( $cluster_rchild{ $cluster1 } );
				
				delete( $cluster_parent{ $lchild } );
				delete( $cluster_parent{ $rchild } );
				
				delete( $leaf_cluster{ $lchild } );
				delete( $leaf_cluster{ $rchild } );
				$leaf_cluster{ $cluster1 } = "leaf";
			}
		}
		######## rchildϴ󣺾ϽкϲԶҶӽڵ㣬ǰڵΪµҶӽڵ #######
		else {
			my $inter_dist12 = cluster_inter_dist( \@l_cluster, \@r_cluster, \%gene_dist );
			my ( $intra_dist1, $intra_dist1_std ) = split( /\t/, cluster_intra_dist( \@l_cluster, \%gene_dist ), 2 );
			my ( $intra_dist2, $intra_dist2_std ) = split( /\t/, cluster_intra_dist( \@r_cluster, \%gene_dist ), 2 );
			
			my $combined_intra_dist = ( $intra_dist1 * $size1 + $intra_dist2 * $size2 ) / ( $size1 + $size2 );
			my $combined_intra_dist_std = ( $size1 - 1 ) * $intra_dist1_std * $intra_dist1_std + ( $size2 - 1 ) * $intra_dist2_std * $intra_dist2_std;
			$combined_intra_dist_std = sqrt( $combined_intra_dist_std / ( $size1 + $size2 - 2 ) );
			
			# ϲ/ȥھھķбȽϣֵԽ˵ӽڵԽԶ
			my $inter_normalize_dist = ( $inter_dist12 - $combined_intra_dist ) / $combined_intra_dist_std;
			
			if( $inter_normalize_dist > $merge_cut ) {
				# ǰڵѾǸڵ㣬׼
				if( !exists( $cluster_parent{ $cluster1 } ) ) {
					if( $size2 >= $min_cluster_size ) {
						print out1 $rchild, "\n";
						print "r";
					}
					print out1 $lchild, "\n";
					print "l";
					print out1 $cluster1, "\n";
					print "c";
					print ":r21\n";
					
					delete( $cluster_lchild{ $cluster1 } );
					delete( $cluster_rchild{ $cluster1 } );
					
					delete( $cluster_parent{ $lchild } );
					delete( $cluster_parent{ $rchild } );
					
					delete( $leaf_cluster{ $lchild } );
					delete( $leaf_cluster{ $rchild } );
					next;
				}
				
				if( $size2 >= $min_cluster_size ) {
					print out1 $rchild, "\n";
					print "r";
				}
				print out1 $lchild, "\n";
				print "l";
				
				print ":i\n";
				
				delete( $cluster_lchild{ $cluster1 } );
				delete( $cluster_rchild{ $cluster1 } );
				
				delete( $cluster_parent{ $lchild } );
				delete( $cluster_parent{ $rchild } );
				
				delete( $leaf_cluster{ $lchild } );
				delete( $leaf_cluster{ $rchild } );
				$leaf_cluster{ $cluster1 } = "leaf";
			}
			else {
				# ǰڵѾǸڵ㣬׼
				if( !exists( $cluster_parent{ $cluster1 } ) ) {
					print out1 $cluster1, "\n";
					print "c";
					print ":r22\n";
					
					delete( $cluster_lchild{ $cluster1 } );
					delete( $cluster_rchild{ $cluster1 } );
					
					delete( $cluster_parent{ $lchild } );
					delete( $cluster_parent{ $rchild } );
					
					delete( $leaf_cluster{ $lchild } );
					delete( $leaf_cluster{ $rchild } );
					next;
				}				
				
				delete( $cluster_lchild{ $cluster1 } );
				delete( $cluster_rchild{ $cluster1 } );
				
				delete( $cluster_parent{ $lchild } );
				delete( $cluster_parent{ $rchild } );
				
				delete( $leaf_cluster{ $lchild } );
				delete( $leaf_cluster{ $rchild } );
				$leaf_cluster{ $cluster1 } = "leaf";
			}
		}
	}
	
	if( ! %leaf_cluster ) {
		last;
	}
}
close( out1 );

#########################
#########################
### sub-routines ########
#########################
#########################

sub cluster_size {
	my @arr1 = split( /:/, $_[0] );
	return $#arr1 + 1;
}

sub cluster1_belong_cluster2 {
	my ( $cluster1, $cluster2 ) = @_;
	my @gene1 = sort { $a <=> $b } split( /:/, $cluster1 );
	my @gene2 = sort { $a <=> $b } split( /:/, $cluster2 );
	my $belong = "true";
	
	my $j = 0;
	for( my $i = 0; $i <= $#gene1; $i++ ) {
		if( $gene1[$i] < $gene2[$j] || $j > $#gene2 ) {
			$belong = "false";
			last;
		}
		
		if( $gene1[$i] > $gene2[$j] ) {
			$i--;
		}
		
		$j++;
	}
	
	return $belong;
}

sub mean {
	my @data=@_;
	
	return sum( @data ) / ( $#data + 1 );
}

sub std {
	my @arr_p = @_;
	
	my $mean = sum( @arr_p )/( $#arr_p + 1 );
	
	my $var = 0;
	for( my $si = 0; $si <= $#arr_p; $si++ ) {
		my $diff = $arr_p[$si] - $mean;
		$var = $var + $diff * $diff;
	}
	$var = $var / $#arr_p;
	
	return sqrt( $var );
}

sub cluster_intra_dist {
	my ( $arr_cluster, $hash_dist ) = @_;
	
	my @cluster1 = @$arr_cluster;
	my @dist1 = ();
	for( my $i = 0; $i < $#cluster1; $i++ ) {
		my $id1 = $cluster1[$i];
		
		for( my $j = $i + 1; $j <= $#cluster1; $j++ ) {
			my $id2 = $cluster1[$j];
			
			if( !exists( $hash_dist->{ "$id1\t$id2" } ) ) {
				print "ERROR in sub-routine: cluster_intra_dist: distance matrix value is missed for $id1\t$id2.\n";
				exit;
			}
			
			push( @dist1, $hash_dist->{ "$id1\t$id2" } );
		}
	}
	
	my $mean1 = mean( @dist1 );
	my $std1 = std( @dist1 );
	
	return join( "\t", $mean1, $std1 );
}

sub cluster_inter_dist {
	my ( $arr_cluster1, $arr_cluster2, $hash_dist ) = @_;
	my @cluster1 = @$arr_cluster1;
	my @cluster2 = @$arr_cluster2;
	my @dist12 = ();
	
	for( my $i = 0; $i <= $#cluster1; $i++ ) {
		my $id1 = $cluster1[$i];
		for( my $j = 0; $j <= $#cluster2; $j++ ) {
			my $id2 = $cluster2[$j];
			
			if( !exists( $hash_dist->{ "$id1\t$id2" } ) ) {
				print "ERROR in sub-routine: cluster_inter_dist: distance matrix value is missed for $id1\t$id2.\n";
				exit;
			}
			
			push( @dist12, $hash_dist->{ "$id1\t$id2" } );
		}
	}
	
	my $mean1 = mean( @dist12 );
	#my $std1 = std( @dist12 );
	
	return join( "\t", $mean1 ); #, $std1 );
}
